// Sokoban versie 2

import junit.framework.TestCase;

public class DoolhofTest extends TestCase {
  private final int RIJEN = 6, KOLOMMEN = 9;
  private Veld[][] bord;
  private Doolhof doolhof;
    
  public void setUp() {
    bord = new Veld[ RIJEN ][ KOLOMMEN ];
    for( int r = 0; r < RIJEN; r++ ) {
      for( int k = 0; k < KOLOMMEN; k++ ) {
        bord[ r ][ k ] = new Veld( r, k );
        if( r == 0 || r == RIJEN - 1 || k == 0 || k == KOLOMMEN -1 )
          bord[r][k].setMuur();
      }
    }
    bord[2][2].setKist( true );
    bord[2][4].setEindveld();
    bord[2][1].setSpeler( true );

    doolhof = new Doolhof( bord );
  }
  
  public void testBord() {
    Veld[][] bord = doolhof.getBord();
    System.out.println();
    for( int r = 0; r < bord.length; r++ ) {
      for( int k = 0; k < bord[0].length; k++ ) {
        Veld veld = bord[ r][k];
        if( veld.isMuur() )
          System.out.print( 'M' );
        else
        if( veld.heeftSpeler() )
          System.out.print( 'S' );
        else
        if( veld.heeftKist() )
          System.out.print( 'K' );
        else
        if( veld.isEindveld() )
          System.out.print( 'E' );
        else
          System.out.print( ' ' );
      }
      System.out.println();
    }
  }
  
  public void testSpelerpositie() {
    Positie spelerPos = doolhof.getSpelerpositie();
    assertEquals( spelerPos.getR(), 2 );
    assertEquals( spelerPos.getK(), 1 );
  }
  
  public static void main( String[] args ) {
    junit.swingui.TestRunner.run( DoolhofTest.class );
  }  
}
