// Versie 3

public class Doolhof {
  private Veld[][] bord;
  private int aantalRijen, aantalKolommen;
  private Veld spelerveld;
  
  public Doolhof( Veld[][] bord ) {
    this.bord = bord;
    // Leg de afmetingen van het bord vast
    aantalRijen = bord.length;
    aantalKolommen = bord[ 0 ].length;
    // Bepaal het veld waarop de speler staat
    for( int r = 0; r < aantalRijen; r++ ) {
      for( int k = 0; k < aantalKolommen; k++ )
        if( bord[r][k].heeftSpeler() )
          spelerveld = bord[r][k];
    }
  }
  
  public Veld[][] getBord() {
    return bord;
  }
  
  public Positie getSpelerpositie() {
    return spelerveld.getPositie();
  }
  
  private Veld getVeld( Positie pos ) {
    return bord[ pos.getR() ][ pos.getK() ];
  }
  
  public void doeZetNoord() {
    Positie spelerpositie = getSpelerpositie();
    Positie buurpositie = spelerpositie.getBuurNoord();
    Veld buurveld = getVeld( buurpositie );
    // Verwijder speler van huidige veld
    spelerveld.setSpeler( false ); 
    // Zet speler op buurveld
    buurveld.setSpeler( true );
    spelerveld = buurveld;
  }

  public void doeZetZuid() {
    Positie spelerpositie = getSpelerpositie();
    Positie buurpositie = spelerpositie.getBuurZuid();
    Veld buurveld = getVeld( buurpositie );
    // Verwijder speler van huidige veld
    spelerveld.setSpeler( false ); 
    // Zet speler op buurveld
    buurveld.setSpeler( true );
    spelerveld = buurveld;
  }

  public void doeZetOost() {
    Positie spelerpositie = getSpelerpositie();
    Positie buurpositie = spelerpositie.getBuurOost();
    Veld buurveld = getVeld( buurpositie );
    // Verwijder speler van huidige veld
    spelerveld.setSpeler( false ); 
    // Zet speler op buurveld
    buurveld.setSpeler( true );
    spelerveld = buurveld;
  }

  public void doeZetWest() {
    Positie spelerpositie = getSpelerpositie();
    Positie buurpositie = spelerpositie.getBuurWest();
    Veld buurveld = getVeld( buurpositie );
    // Verwijder speler van huidige veld
    spelerveld.setSpeler( false ); 
    // Zet speler op buurveld
    buurveld.setSpeler( true );
    spelerveld = buurveld;
  }
}
