// Versie 5
public class Doolhof {
  private Veld[][] bord;
  private int aantalRijen, aantalKolommen;
  private Veld spelerveld;
  
  public Doolhof( Veld[][] bord ) {
    this.bord = bord;
    // Leg de afmetingen van het bord vast
    aantalRijen = bord.length;
    aantalKolommen = bord[ 0 ].length;
    // Bepaal het veld waarop de speler staat
    for( int r = 0; r < aantalRijen; r++ ) {
      for( int k = 0; k < aantalKolommen; k++ )
        if( bord[r][k].heeftSpeler() )
          spelerveld = bord[r][k];
    }
  }
  
  public Veld[][] getBord() {
    return bord;
  }
  
  public Positie getSpelerpositie() {
    return spelerveld.getPositie();
  }
  
  private Veld getVeld( Positie pos ) {
    return bord[ pos.getR() ][ pos.getK() ];
  }
  
  public void doeZet( Richting richting ) {
    Positie spelerpositie = getSpelerpositie();
    Positie buurpositie = spelerpositie.getBuurpositie( richting );
    Veld buurveld = getVeld( buurpositie );

    if( buurveld.isLeeg() )
      verplaatsSpeler( buurveld );
    else
    if( buurveld.heeftKist() ) {
      Veld buurveldVanKist =
        getVeld( buurpositie.getBuurpositie( richting ) );
      if( buurveldVanKist.isLeeg() ) {
        // Verplaats de kist en de speler
        buurveld.setKist( false );
        buurveldVanKist.setKist( true );
        verplaatsSpeler( buurveld );
      }
    }
  }
  
  private void verplaatsSpeler( Veld naarVeld ) {
    spelerveld.setSpeler( false );
    naarVeld.setSpeler( true );
    spelerveld = naarVeld;
  }
  
  public boolean isSpelKlaar() {
    for( int r = 0; r < aantalRijen; r++ ) {
      for( int k = 0; k < aantalKolommen; k++ ) {
        Veld veld = bord[r][k];
        if( veld.isEindveld() && !veld.heeftKist() )
          return false;
      }
    }
    return true;    
  }
}
