// Kubus3 
// Grafische gebruikersinterface
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

public class KubusApplicatie3 extends JFrame {
  public KubusApplicatie3() {
    setContentPane( new TekstView( this ) );
    setSize( 300, 150 );
    setTitle( "Kubusapplicatie 3" );
    setDefaultCloseOperation( EXIT_ON_CLOSE );
    setVisible( true );
  }
  
  public static void main( String[] args ) {
    new KubusApplicatie3();
  }
}

class TekstView extends JPanel {
  private JTextField zijdeVak, inhoudVak, oppervlakteVak;
  private Kubus kubus;
  JFrame frame;

  public TekstView( JFrame frame ) {
    this.frame = frame;
    kubus = new Kubus( 0 );
    
    Box labelBox = Box.createVerticalBox();
    labelBox.add( new JLabel( "Zijde" ) );
    labelBox.add( new JLabel( "Inhoud" ) );
    labelBox.add( new JLabel( "Oppervlakte" ) );

    zijdeVak = new JTextField( 10 );
    zijdeVak.addActionListener( new ZijdeHandler() );
    
    inhoudVak = new JTextField( 10 );
    inhoudVak.setEditable( false );

    oppervlakteVak = new JTextField( 10 );
    oppervlakteVak.setEditable( false );
    
    Box tekstvakBox = Box.createVerticalBox();
    tekstvakBox.add( zijdeVak );
    tekstvakBox.add( inhoudVak );
    tekstvakBox.add( oppervlakteVak );
    
    Box totaalBox = Box.createHorizontalBox();
    totaalBox.add( labelBox );
    totaalBox.add( Box.createHorizontalStrut( 20 ) );
    totaalBox.add( tekstvakBox );

    setBorder( new EmptyBorder( 20, 20, 20, 20 ) );
    add( totaalBox );
  }

  class ZijdeHandler implements ActionListener {
    public void actionPerformed( ActionEvent e ) {
      String s = zijdeVak.getText();
      try {
        double zijde = Double.parseDouble( s );
        kubus.setZijde( zijde );

        inhoudVak.setText( String.format( "%12.2f", kubus.getInhoud() ) );
        oppervlakteVak.setText( String.format( "%12.2f", kubus.getOppervlakte() ) );
      }   
      catch( NumberFormatException ex ) {
        JOptionPane.showMessageDialog(
          frame, "Invoer " + s + " is geen getal",
          "Fout in invoer", JOptionPane.WARNING_MESSAGE );
      }
    }
  }
}

class Kubus {
  private double zijde;
  
  public Kubus( double zijde ) {
    this.zijde = zijde;
  }

  public void setZijde( double zijde ) {
    this.zijde = zijde;
  }
    
  public double getInhoud() {
    return zijde * zijde * zijde;
  }
  
  public double getOppervlakte() {
    return 6 * zijde * zijde;
  }
}