public class Veld implements Cloneable {
  private Positie positie;
  private boolean heeftSpeler,
                  heeftKist,
                  isMuur,
                  isEindveld;
  
  public Veld( int r, int k ) {
    positie = new Positie( r, k );
  }

  // Methoden met package access
  void setSpeler( boolean speler ) {
    heeftSpeler = speler;
  }
  
  void setKist( boolean kist ) {
    heeftKist = kist;
  }
  
  void setMuur() {
    isMuur = true;
  }
  
  void setEindveld() {
    isEindveld = true;
  }

  // Methoden met public access                  
  public boolean heeftSpeler() {
    return heeftSpeler;
  }
  
  public boolean heeftKist() {
    return heeftKist;
  }
  
  public boolean isMuur() {
    return isMuur;
  }
    
  public boolean isEindveld() {
    return isEindveld;
  }
  
  public Positie getPositie() {
    return positie;
  }
  
  public boolean isLeeg() {
    return !isMuur && !heeftKist && !heeftSpeler;
  }
  
  public Object clone() {
    try {
      return super.clone();
    }
    catch ( CloneNotSupportedException e ) {
      return null;
    }
  }
  
  // Alternatief voor clone()
  public Veld getKopie() {
    // Maak een kopie 
    Veld veld = new Veld( positie.getR(), positie.getK() );
    veld.setSpeler( this.heeftSpeler );
    veld.setKist( this.heeftKist );
    if( this.isMuur )
      veld.setMuur();
    if( this.isEindveld )
     veld.setEindveld();
    return veld;
  }
  
}
