import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class Controller extends KeyAdapter {
  private Doolhof doolhof;
  private Memento memento;
  JButton undoKnop;
  
  public Controller( Doolhof doolhof ) {
    this.doolhof = doolhof;
    
    JPanel totaalPaneel = new JPanel();
    
    // Regel het afhandelen van de toets-events
    InputMap inputMap = totaalPaneel.getInputMap( JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT );
    inputMap.put( KeyStroke.getKeyStroke( KeyEvent.VK_UP, 0 ),    "gaNoord" );
    inputMap.put( KeyStroke.getKeyStroke( KeyEvent.VK_RIGHT, 0 ), "gaOost" );
    inputMap.put( KeyStroke.getKeyStroke( KeyEvent.VK_DOWN, 0 ),  "gaZuid" );
    inputMap.put( KeyStroke.getKeyStroke( KeyEvent.VK_LEFT, 0 ),  "gaWest" );
    
    ActionMap actionMap = totaalPaneel.getActionMap();
    actionMap.put( "gaNoord", new VerplaatsAction( Richting.NOORD ) );
    actionMap.put( "gaOost",  new VerplaatsAction( Richting.OOST ) );
    actionMap.put( "gaZuid",  new VerplaatsAction( Richting.ZUID ) );
    actionMap.put( "gaWest",  new VerplaatsAction( Richting.WEST ) );

    totaalPaneel.setLayout( new BorderLayout() );
    
    DoolhofView dhview = new DoolhofView();
    dhview.update( doolhof, null );
    doolhof.addObserver( dhview );
 
    totaalPaneel.add( dhview, BorderLayout.CENTER );
    totaalPaneel.addKeyListener( this );    
    
    JPanel knoppenPaneel = new JPanel();
    undoKnop = new JButton( "Ongedaan maken" );
    //undoKnop.setEnabled( false );
    undoKnop.addActionListener( new UndoListener() );
    
    knoppenPaneel.add( undoKnop );
    totaalPaneel.add( knoppenPaneel, BorderLayout.SOUTH );
    
    JFrame frame = new SokobanApplicatie3( totaalPaneel );
  }
  
  // Inwendige klasssen voor afhandeling van events
  
  class UndoListener implements ActionListener {
    public void actionPerformed( ActionEvent e  ) {
      if( memento != null ) {
        doolhof.zetTerug( memento );
        memento = null;
        undoKnop.setEnabled( false );
      }
    }
  }
  
  class VerplaatsAction extends AbstractAction {
    private Richting richting;
    
    public VerplaatsAction( Richting richting ) {
      this.richting = richting;
    }
    
    public void actionPerformed( ActionEvent e ) {
      memento = doolhof.getMemento( richting );
      doolhof.doeZet( memento );
      undoKnop.setEnabled( true );
    }
  }
}
	