// Objecten lezen met ObjectInputStream en FileInputStream
import java.io.*;
import java.util.*;

public class ObjectenLezen {
  public static void main( String[] args ) {
    Bestelling b1 = null, b2 = null;
    
    String filenaam = "C:\\Temp\\test.dat";
    try {
      ObjectInputStream in =
           new ObjectInputStream( new FileInputStream( filenaam ) );

      b1 = (Bestelling) in.readObject();
      b2 = (Bestelling) in.readObject();

      in.close();
    }
    catch( ClassNotFoundException e ) {
      System.out.println( "Onbekende klasse bij inlezen bestand " + filenaam );
    }
    catch( IOException e ) {
      System.out.println( "Fout bij openen bestand " + filenaam );
      e.printStackTrace();
    }
    
    b1.print();
    b2.print();
  }
}


class Bestelling implements Serializable {
  private ArrayList<Artikel> lijst;
  
  public Bestelling() {
    lijst = new ArrayList<Artikel>();
  }
  
  public void voegtoe( Artikel a ) {
    lijst.add( a );
  }

  public void print() {
    for( Artikel a : lijst ) 
      System.out.println( a );
    System.out.println();
  }
}

class Artikel implements Serializable {
  private String omschrijving;
  
  public Artikel( String omschrijving ) {
    this.omschrijving = omschrijving;
  }
  
  public String toString() {
    return omschrijving;
  }
}