// Objecten schrijven met ObjectOutputStream en FileOutputStream
import java.io.*;
import java.util.*;

public class ObjectenSchrijven {
  public static void main( String[] args ) {
    // Maak eerst twee Bestelling-objecten
    Bestelling bestelling1 = new Bestelling();
    bestelling1.voegtoe( new Artikel( "dvd-speler" ) );
    bestelling1.voegtoe( new Artikel( "mobiele telefoon" ) );
    
    Bestelling bestelling2 = new Bestelling();
    bestelling2.voegtoe( new Artikel( "broodje kroket" ) );
    
    String filenaam = "C:\\Temp\\test.dat";
    try {
      ObjectOutputStream uit =
           new ObjectOutputStream( new FileOutputStream( filenaam ) );

      uit.writeObject( bestelling1 );
      uit.writeObject( bestelling2 );

      uit.close();
    }
    catch( IOException e ) {
      System.out.println( "Fout bij openen bestand " + filenaam );
      e.printStackTrace();\\
    }
  }
}


class Bestelling implements Serializable {
  private ArrayList<Artikel> lijst;
  
  public Bestelling() {
    lijst = new ArrayList<Artikel>();
  }
  
  public void voegtoe( Artikel a ) {
    lijst.add( a );
  }

  public void print() {
    for( Artikel a : lijst ) 
      System.out.println( a );
    System.out.println();
  }
}

class Artikel implements Serializable {
  private String omschrijving;
  
  public Artikel( String omschrijving ) {
    this.omschrijving = omschrijving;
  }
  
  public String toString() {
    return omschrijving;
  }
}
